/* -------------------------------------------------------------------- */
/* SMS Client, send messages to mobile phones and pagers		*/
/*									*/
/* sms_modem.c								*/
/*									*/
/*  Copyright (C) 1997,1998 Angelo Masci				*/
/*									*/
/*  This library is free software; you can redistribute it and/or	*/
/*  modify it under the terms of the GNU Library General Public		*/
/*  License as published by the Free Software Foundation; either	*/
/*  version 2 of the License, or (at your option) any later version.	*/
/*									*/
/*  This library is distributed in the hope that it will be useful,	*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*/
/*  Library General Public License for more details.			*/
/*									*/
/*  You should have received a copy of the GNU Library General Public	*/
/*  License along with this library; if not, write to the Free		*/
/*  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.	*/
/*									*/
/*  You can contact the author at this e-mail address:			*/
/*									*/
/*  angelo@styx.demon.co.uk						*/
/*									*/
/* -------------------------------------------------------------------- */
/* $Id: sms_modem.c,v 4.2 1998/01/17 22:49:15 root Exp root $
   -------------------------------------------------------------------- */

#include <stdio.h>
#include <termios.h>
#include <strings.h>
#include <stdlib.h>

#include <dial/modems.h>

#include "parserc.h"
#include "sms_modem.h"
#include "logfile.h"

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void SMS_setup_comm_params(int fd, char *params)
{
	struct 	termios 
		trm;

	
	if (params == NULL)
	{	return;
	}


	lprintf(LOG_VERBOSE, "Setting communications parameters: %s\n", params);

	if (strcmp(params, "8N1") == 0)
	{
		/* Default - No ACTION */
	}
	else if (strcmp(params, "7E1") == 0)
	{
		tcgetattr(fd, &trm);

		trm.c_cflag &= ~(CSIZE|CSTOPB|PARODD);
		trm.c_cflag |= CS7|PARENB;

		tcsetattr(fd, TCSAFLUSH, &trm);
	}
}        

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
int SMS_dial(char *number, char *service)
{
	int 	fd;
	char 	*params;

	
	params = get_comms_params(service);
#if 0
	/* Libmodem-1.1 supports cofiguration of	*/
	/* modem parameters through a call to		*/
	/* setmdmdata()					*/

	if (params != NULL)
	{
		setmdmdata(params[0],
		           params[1],
		           params[2]);
	}
	else
	{	setmdmdata('8','N','1');
	}
#endif 
	fd = dial(number);
#if 1
	/* Libmodem-1.0.0 does not supports 	*/
	/* cofiguration of modem parameters.	*/
	/* Use own function to change them.	*/


	if (fd >= 0)
	{	
		SMS_setup_comm_params(fd, params);
	}
#endif
	if (params != NULL)
	{	free(params);
	}

	return fd;
}
